    ;FAT12 File Loader IPL
    ; by Murachue.
    ASSUME cs:code,ds:code,es:code
CODE    SEGMENT
    ORG 100h
start:
    jmp short begin
    NOP

	;Singature
    DB  'LOADERv3'

    DB  00,02,01,01,00
    DB  02,0E0h,00,40h,0Bh,0F0h,09,00,12h,00,02,0,0,0,0,0
    DB  0,0,0,0,0,0,29h
    DB  0FFh,0FFh,0FFh,0FFh
    DB  "NO NAME    "
    DB  "FAT12   "
    ;There are 59 bytes.

TMP DW  0
CNT DB  0

FAT_SEG EQU 2000h
DIR_SEG EQU 3000h
PRG_SEG EQU 1000h

begin:
	CLI
    MOV     AX,07B0h
	MOV     DS,AX
	MOV     ES,AX
	MOV     SS,AX
    MOV     SP,0100H
    STI

;LoadDIR
    mov cx,0002h
    mov dx,0100h
    xor bx,bx
    mov ax,DIR_SEG
    mov es,ax
    mov CNT,14
    call readisk

    mov cx,16*14
flod:
    cmp byte es:[bx],0E5h
    jne fl_ok
    call addes
    jmp short flod
fl_ok:
    cmp byte es:[bx],0h
    jne fl_ok2
    call addes
    jmp short flod
fl_ok2:
    push cx
    push bx

    mov bp,offset FNM
    mov cx,11
strcmp:
    mov ax,es:[bx]
    cmp ax,cs:[bp]
    jnz dmp
    inc bx
    inc TMP
    loop strcmp
dmp:
    test cx,cx
    jz  ok

    pop bx
    pop cx
    call addes
    loop flod
    jmp err
ok:
    mov ax,0E20h
    int 10h
;LoadFAT
    mov cx,0002h
    mov dx,0000h
    xor bx,bx
    mov ax,FAT_SEG
    mov es,ax
    mov CNT,9
    call readisk

;End-
endo:
    Xor ax,ax
    int 16h
    int 19h

readisk:
    mov ax,0201h
    int 13h

    mov ax,0EB1h
    int 10h

    call addes

    call ads

    dec cnt
    cmp cnt,0
    jnz readisk

    ret
ads:
    inc cl
    cmp cl,19
    je  ads_hed
    ret
ads_hed:
    mov cl,1
    inc dh
    cmp dh,2
    je  ads_cyl
    ret
ads_cyl:
    mov dh,0
    inc ch
    ret
addes:
    mov ax,es
    add ax,20h
    mov es,ax
    ret
err:
    mov ah,03h
    mov bl,0
    int 10h

    MOV     AX,07B0h
	MOV     ES,AX

    mov ax,1301h
    mov bx,0004h
    mov bp,offset EMSG
    mov cx,EMSL
    int 10h
forever:
    jmp endo

FNM DB  "FILENAMEEXT"
EMSG DB "Error"
EMSL    equ $-EMSG
LMSG DB "Loading..."
LMSL equ $-LMSG

ORG 2FEh
    DB  55h,0AAh
CODE    ENDS
END     START
